// ftplotDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "ftplot.h"
#include "ftplotDlg.h"
#include "ftplotlib.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFtplotDlg Dialogfeld

CFtplotDlg::CFtplotDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFtplotDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFtplotDlg)
		// HINWEIS: Der Klassenassistent fgt hier Member-Initialisierung ein
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFtplotDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFtplotDlg)
		// HINWEIS: Der Klassenassistent fgt an dieser Stelle DDX- und DDV-Aufrufe ein
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFtplotDlg, CDialog)
	//{{AFX_MSG_MAP(CFtplotDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_Test, OnTest)
	ON_BN_CLICKED(IDC_FUNKTION, OnFunktion)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFtplotDlg Nachrichten-Handler

BOOL CFtplotDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// ZU ERLEDIGEN: Hier zustzliche Initialisierung einfgen
	
	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CFtplotDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CFtplotDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CFtplotDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

static double FunSinExp(double X)
{
    return sin(X) * exp(-X / 10);
}

///////////////////////////////////////////////////////////////////////////////////////////////

void FunktionPlot(ftPlotter& plotter)
{
    double FunMin, FunMax;
    CString FunText;
    double XA, XE, X;
    double X0, X1, X2, Y1, Y2, YA, YE;

    FunText = "Sin(x)*Exp(-x/10)";
    XA = 0;
    XE = 62.8;
  
    FunMin = FunSinExp(XA);
    FunMax = FunSinExp(XA);
  
    for(X = XA; X<= XE; X += ((XE - XA) / 200))
    {
        if (FunSinExp(X) > FunMax)
            FunMax = FunSinExp(X);
        if (FunSinExp(X) < FunMin) 
            FunMin = FunSinExp(X);
    }
  
    X1 = XA - (XE - XA) / 20;
    X2 = XE + (XE - XA) / 20;
    Y1 = FunMin - (FunMax - FunMin) / 20;
    Y2 = FunMax + (FunMax - FunMin) / 20;
    XA = 10;
    XE = plotter.GetXMax() - 10;
    YA = 10;
    YE = plotter.GetYMax() - 10;

    plotter.Axis(XA, YA, XE, YE, X1, Y1, X2, Y2, true, "X", FunText);
  
    plotter.Move(X1 + (X2 - X1) / 22, FunSinExp(X));
  
    for(X0 = X1 + (X2 - X1) / 22; X0 <= X2 - (X2 - X1) / 22; X0 += ((X2 - X1) / 220))
        plotter.Line(X0, FunSinExp(X0));
}

void TestPlot(ftPlotter& plotter)
{
    // plotter.Origin();
    // plotter.Char(10, 50, "ABCDEFGHIJKLMNOPQRSTUVWXYZ", 0, 4);
    // plotter.Char(10, 20, "abcdefghijklmnopqrstuvwxyz", 0, 4);
    // plotter.Char(100, 100, "Hoch", 1, 4);
    // plotter.Box(100, 200, 100, 200, -60);
    // plotter.Circle(300, 250, 100, 100, 0, 360);
    // plotter.Axis(20, 20, 660, 480, -50, -50, 50, 100, 1, "XAchse", "YAchse");

    plotter.Move( 50, 150);
    plotter.Move(100, 150);
    plotter.Line(100, 100);
    plotter.Line( 50, 100);

	/*
    plotter.Move(150,  50);
    plotter.Move(100,  50);
    plotter.Line(100, 100);
    plotter.Line(150, 100);*/
}

void CFtplotDlg::OnTest() 
{
    /*
	StartFtPlot();
	TestPlot();
	StopFtPlot();*/
    
    ftPlotter plotter("COM1");
    TestPlot(plotter);
}

void CFtplotDlg::OnFunktion() 
{
    /*
	StartFtPlot();
	FunktionPlot();
	StopFtPlot();*/

    ftPlotter plotter("COM1");
    FunktionPlot(plotter);
}
